int get_structure(Term **goal_ptr, char *functor, int arity) {
    /* unify *goal_ptr and some struct */

    save_mode();

    if (mode == Read_Mode) {
        /* Handle bound *goal_ptr: */
        Term *goal = deref(*goal_ptr);

        switch (goal->type) {
        case Is_Variable:
            trail_binding(goal);
            goal->term.variable.term = put_structure(functor, arity);
            mode = Write_Mode;      /* signal uninitialized goals */
            return 1;
        case Is_Structure:
            return (goal->term.structure.arity == arity
            && strcmp(goal->term.structure.functor, functor) == 0
            );
        default:
            return 0;
        }
    }
    else {  /* mode == Write_Mode */
        *goal_ptr = put_structure(functor, arity);
        return 1;
    }
}
