/* ======== grandparent2.i for Flat Unification ======== */

/* ======== code for grandparent_2, 1 alternative ======== */

static void
grandparent_2_clause_1(Term *goal_arg1, Term *goal_arg2, Action goal_list_tail) {
    Term *X = put_variable("X");
    Term *Z = put_variable("Z");
    int trail_mark;

    set_trail_mark(&trail_mark);
    if (unify_terms(goal_arg1, X) &&  unify_terms(goal_arg2, Z)) {
        Term *Y = put_variable("Y");

        void grandparent_2_clause_1_goal_3(void) {
            goal_list_tail();
        }

        void grandparent_2_clause_1_goal_2(void) {
            parent_2(Y, goal_arg2, grandparent_2_clause_1_goal_3);
        }

        void grandparent_2_clause_1_body(void) {
            parent_2(goal_arg1, Y, grandparent_2_clause_1_goal_2);
        }

        grandparent_2_clause_1_body();
    }
    restore_bindings_until_trail_mark(&trail_mark);
}

void
grandparent_2(Term *goal_arg1, Term *goal_arg2, Action goal_list_tail) {
    /* OR of all definitions */
    grandparent_2_clause_1(goal_arg1, goal_arg2, goal_list_tail);
}
