int unify_structures(
    struct structure *s_goal, struct structure *s_head
) {
    int counter;

    if (s_goal->arity != s_head->arity
    ||  strcmp(s_goal->functor, s_head->functor) != 0
    ) return 0;

    for (counter = 0; counter < s_head->arity; counter++) {
        if (!unify_terms(
            s_goal->components[counter], s_head->components[counter]
        ))  return 0;
    }

    return 1;
}
