void unify_non_variables(Term *goal_arg, Term *head_arg, Action goal_list_tail) {
    /* Handle terms of different type: */
    if (goal_arg->type != head_arg->type) return;

    switch (goal_arg->type) {
    case Is_Constant:
        if (strcmp(goal_arg->term.constant, head_arg->term.constant) == 0) {
            goal_list_tail();
        }
        break;
    case Is_Structure:
        unify_structures(
            &goal_arg->term.structure, &head_arg->term.structure, goal_list_tail
        );
        break;
    }
}
