void unify_structures(
    struct structure *s_goal, struct structure *s_head,
    Action goal_list_tail
) {
    int counter = 0;
    Term **components_goal = s_goal->components;
    Term **components_head = s_head->components;

    void unify_components(void) {
        if (counter == s_head->arity) {
            goal_list_tail();
        }
        else {
            int cnt = counter++;

            unify_terms(
                components_goal[cnt], components_head[cnt],
                unify_components
            );
        }
    }

    if (s_goal->arity != s_head->arity
    ||  strcmp(s_goal->functor, s_head->functor) != 0
    ) return;

    unify_components();
}
