{
#include    <stdio.h>
#include    <malloc.h>

#include    "tree.h"
}

%lexical get_next_token_class;
%token IDENTIFIER;

%start Main_Program, main;

main {struct expr *result;}:
    expression(&result) {print_expr(result); printf("\n");}
;

expression(struct expr **ep):
    ','                         /* prefix, to fake LL(1); see Makefile */
    {(*ep) = new_expr(); (*ep)->type = '-';}
    expression(&(*ep)->expr) '-' term(&(*ep)->term)
|   {(*ep) = new_expr(); (*ep)->type = 'T';}
    term(&(*ep)->term)
;

term(struct term **tp):
    {(*tp) = new_term(); (*tp)->type = 'I';}
    IDENTIFIER
;
