int get_structure(Term *goal_arg, char *functor, int arity) {
    /* Handle bound goal_arg: */
    Term *goal = deref(goal_arg);

    switch (goal->type) {
    case Is_Variable:
        trail_binding(goal);
        goal->term.variable.term = put_structure(functor, arity);
        initialize_components(goal->term.variable.term);
        return 1;           /* always succeeds */
    case Is_Structure:
        return (goal->term.structure.arity == arity
        && strcmp(goal->term.structure.functor, functor) == 0
        );
    default:
        return 0;
    }
}
