int get_variable(Term *goal_arg, Term *var_arg) {
    /* unify goal and an unbound or bound head variable var */
    Term *goal = deref(goal_arg);
    Term *var = deref(var_arg);   /* var may already be bound */

    if (var->type == Is_Variable) {
        trail_binding(var);
        var->term.variable.term = goal;
        return 1;
    }
    else {
        /* no further compilation possible */
        /* call interpreter */
        return unify_terms(goal, var);
    }
}
