int get_constant(Term **goal_ptr, char *text) {
    /* unify *goal_ptr and constant text */

    if (mode == Read_Mode) {
        /* Handle bound *goal_ptr: */
        Term *goal = deref(*goal_ptr);

        switch (goal->type) {
        case Is_Variable:
            trail_binding(goal);
            goal->term.variable.term = put_constant(text);
            return 1;
        case Is_Constant:
            return strcmp(goal->term.constant, text) == 0;
        default:
            return 0;
        }
    }
    else {  /* mode == Write_Mode */
        *goal_ptr = put_constant(text);
        return 1;
    }
}
