void built_in_between(
    Term *t1, Term *t2, Term *t3,
    Action goal_list_tail
) {
    Term *arg = deref(t1);
    Term *expr1 = evaluate_expression(t2);
    Term *expr2 = evaluate_expression(t3);

    if (arg->type == Is_Variable) {
        int from = atoi(expr1->term.constant);
        int to = atoi(expr2->term.constant);
        int i;

        for (i = from; i < to; i++) {
            arg->term.variable.term = put_integer(i);
            goal_list_tail();
            arg->term.variable.term = 0;
        }
    }
    else
    if (arg->type == Is_Constant
    &&  atoi(expr1->term.constant) <= atoi(arg->term.constant)
    &&  atoi(arg->term.constant) <= atoi(expr2->term.constant)
    ) {
        goal_list_tail();
    }
}
