/* ======== program.c for Simple Compiled Prolog Program ======== */
/*
    This is a sample C translation of the Prolog clauses

        grandparent(X, Z) :- parent(X, Y), parent(Y, Z).
        parent(arne, james).
        parent(arne, sachiko).
        parent(koos, rivka).
        parent(sachiko, rivka).
        parent(truitje, koos).
*/

#include    "data.h"
#include    "action.h"
#include    "program.h"
#include    "goalargs.h"
#include    "unify.h"

#include    "grandparent2.i"
#include    "parent2.i"
